#include "lib/odbxlib.h"



#ifdef HAVE_LIBDL


#ifdef HAVE_DLFCN_H
#include <dlfcn.h>
#endif

#include <stdio.h>



int _odbx_lib_open( struct odbx_t* handle, const char* backend )
{
	size_t len, plen;
	char lib[ODBX_PATHSIZE+1];
	void (*odbxreg)(struct odbx_ops**);


	len = plen = snprintf( lib, ODBX_PATHSIZE, LIBPATH );
	len += snprintf( lib + len, ODBX_PATHSIZE, "lib" );
	len += snprintf( lib + len, ODBX_PATHSIZE - len, backend );
	len += snprintf( lib + len, ODBX_PATHSIZE - len, "backend.so" );

	if( len > ODBX_PATHSIZE )
	{
		return -ODBX_ERR_TOOLONG;
	}
	lib[len] = '\0';

	if( ( handle->backend = dlopen( lib, RTLD_LAZY ) ) == NULL )
	{
		if( ( handle->backend = dlopen( lib + plen, RTLD_LAZY ) ) == NULL )
		{
			return -ODBX_ERR_NOTEXIST;
		}
	}

	if( ( *(void **) (&odbxreg) = dlsym( handle->backend, "odbxdrv_register" ) ) == NULL )
	{
		return -ODBX_ERR_NOOP;
	}

	(*odbxreg)( &(handle->ops) );
	return ODBX_ERR_SUCCESS;
}



int _odbx_lib_close( struct odbx_t* handle )
{
	if( dlclose( handle->backend ) != 0 )
	{
		return ODBX_ERR_PARAM;
	}

	return ODBX_ERR_SUCCESS;
}



#endif
